object solution {

def main(args: Array[String]) {
val lines = sc.textFile("./urldata.txt")
val iters = 10
	
//Creating the graph
val links = lines.map(s => s.split("\\s+")).map(arr => arr(0) -> arr(1)).distinct().groupByKey().cache()

//Put the initial value for pagerank
var ranks = links.mapValues(v => 1.0)

for (i <- 1 to iters) {
//Map each element (page) p contribute rank_p / |neighbors_p| to its neighbors
val contribs = links.join(ranks).values.flatMap{ case (urls, rank) =>
 val size = urls.size
 urls.map(url => (url, rank / size))
}
//Set each page’s rank to 0.15 + 0.85 × contribs
ranks = contribs.reduceByKey(_ + _).mapValues(0.15 + 0.85 * _)
}

//Retrieve RDD contents as a local collection
val output = ranks.collect()
output.foreach(tup => println(tup._1 + " has rank: " + tup._2 + "."))
spark.stop()
}
}
